
/*
 * Copyright 2011-2022 Cuberite Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// StringCompression.h

// Interfaces to the wrapping functions for compression and decompression

#pragma once





struct libdeflate_compressor;
struct libdeflate_decompressor;





namespace Compression
{
	/** Contains the result of a compression or extraction operation. */
	struct Result
	{
		using Static = std::array<std::byte, 128 KiB>;
		using Dynamic = std::unique_ptr<std::byte[]>;

		static constexpr size_t StaticCapacity = sizeof(Compression::Result::Static) / sizeof(Compression::Result::Static::value_type);

		/** Returns a view (of type char) of the internal store. */
		std::string_view GetStringView() const;

		/** Returns a view (of type std::byte) of the internal store. */
		ContiguousByteBufferView GetView() const;

		/** A store allocated on either the stack or heap. */
		std::variant<Static, Dynamic> Storage;

		/** The length of valid data in the store. */
		size_t Size;
	};

	/** Contains routines for data compression. */
	class Compressor
	{
	public:

		/** Creates a new compressor instance with a compression factor [0-12]. */
		Compressor(int CompressionFactor = 6);
		~Compressor();

		Result CompressGZip(ContiguousByteBufferView Input);
		Result CompressZLib(ContiguousByteBufferView Input);
		Result CompressZLib(const void * Input, size_t Size);

	private:

		template <auto Algorithm>
		Result Compress(const void * Input, size_t Size);

		libdeflate_compressor * m_Handle;
	};

	/** Contains routines for data extraction. */
	class Extractor
	{
	public:

		/** Creates a new extractor instance. */
		Extractor();
		~Extractor();

		Result ExtractGZip(ContiguousByteBufferView Input);
		Result ExtractZLib(ContiguousByteBufferView Input);
		Result ExtractZLib(ContiguousByteBufferView Input, size_t UncompressedSize);

	private:

		template <auto Algorithm> Result Extract(ContiguousByteBufferView Input);
		template <auto Algorithm> Result Extract(ContiguousByteBufferView Input, size_t UncompressedSize);

		libdeflate_decompressor * m_Handle;
	};
}
